#!/usr/bin/perl -w
use strict;
use JSON;
use Digest::MD5 qw(md5 md5_hex md5_base64);

our $api3uri = "http://bug.thesite.com/api3.php";
our $username= 'admin';
our $password= '8767073e47086a82357b6db3c9a08629';
our $API_KEY = '';

our $curl    = "curl -m 10 --retry 3 -f -s";

sub encode_uri
{
	my $uri = shift;
	$uri=~s/([^\w()'*~!.-])/sprintf '%%%02x', ord $1/eg;   # encode'
	return $uri;
}

sub get_fixed
{
	my ($s,$ot) = @_;
	my @v = ();
	$s=~s/^\s+//s;
	$s=~s!^fix\s*bug\s* (?:
   	    \#(\d+)(?{push @v, $^N}) [\s,]*
		)+!!x;
	$s=~s/^\s+//s;
	$$ot = $s;
	return @v;
}

sub modify_bug
{
	my ($bugno, $sinfo)=@_;
}

sub make_memo
{
	my ($repo, $rev, $transid) = @_;
	my $info1 = `svnlook info "$repo" -r $rev`;
	my @info = split(/\r*\n/, $info1, 4);
	my @changed = `svnlook changed "$repo" -r $rev`;
	my $chg_info = '';
	foreach (@changed)
	{
		chomp;
		my (undef, $fn) = split(/\s+/, $_, 2);
		$chg_info .= "$_ viewdiff($repo|$fn|$rev)\n";
	}

	my $t = '';
	my @fbugs = &get_fixed($info[3], \$t);

	my $sinfo = <<EOF;
[b]修改人:[/b] $info[0]
[b]修改时间:[/b] $info[1]
[b]修改记录:[/b]
$chg_info
EOF
	$sinfo=~s/\r*\n\r*\n$/\r\n/s;
	$sinfo .= "说明：\r\n$t\r\n" if($t);
	$sinfo=~s/(?:\r*\n)+$/\r\n/s;
	if ($#fbugs >= 0)
	{
		my $session = decode_json(`$curl "$api3uri?mode=getsid"`);
		## {"status":"success","code":0,"info":"\u64cd\u4f5c\u6210\u529f","sessionname":"PHPSESSID","sessionid":"jerqrhin09a7t6ksa1fahb4v24","rand":"c58ef"}
		my $auth = md5_hex(md5_hex($username.$password).$API_KEY.$session->{rand});
		my $login = decode_json(`$curl "$api3uri?mode=login&$session->{sessionname}=$session->{sessionid}&username=$username&auth=$auth"`);
		## {"status":"success","code":0,"info":"\u64cd\u4f5c\u6210\u529f","timeout":1431243272}
		if ($login->{status} ne 'success')
		{
			print STDERR "invalid password. recofnig.\n";
			return '';
		}

		my $acnote = encode_uri($sinfo);
		foreach (@fbugs)
		{
			my $bugno = $_ + 0;
			next if ($bugno == 0);
			print "update bug $bugno ";
			my $result = 'FAIL';
			my $bug = decode_json(`$curl "$api3uri?mode=getbug&$session->{sessionname}=$session->{sessionid}&id=$bugno"`);
			if ($bug->{status} eq 'success')
			{
				my $tt = decode_json(`$curl "$api3uri?mode=updatebug&$session->{sessionname}=$session->{sessionid}" -d "id=$bugno&action_note=$acnote"`);
				$result = "OK" if ($tt->{status} eq 'success');
			}
			print "$result\n";
		}
	}
}

if ($#ARGV == 2)
{
	make_memo($ARGV[0], $ARGV[1], $ARGV[2]);
}
else
{
	make_memo("/opt/svn/testdo", '10', '9-9');
}
